(*  
    FAR manager plugin utilities 
    (c) 2000-2001 Eugene Kotlyarov ek@oris.ru http://esk.nm.ru/far
*)
unit FarUtil;
interface
uses Windows;

procedure SetRegKey(sKey:PChar;Value:DWORD);
function GetRegKey(sKey,sValueName:PChar;DefaultValue:DWORD):DWORD;
function GetPluginRegKey(sValueName:PChar;DefaultValue:DWORD):DWORD;

var 
  sRegPktKey:string;

implementation
uses FarIntf, SysUtils;

procedure SetRegKey(sKey:PChar;Value:DWORD);
var
  Keybuf,buf:array[0..255] of char;
  Key:HKEY;
  dwDisposition:DWORD;
begin
  StrPCopy(buf,sRegPktkey);
  StrCat(StrCopy(KeyBuf,Info.RootKey),buf);
  RegCreateKeyEx(HKEY_CURRENT_USER,
                 KeyBuf,
                 0,nil,
                 REG_OPTION_NON_VOLATILE,
                 KEY_ALL_ACCESS,
                 nil,key,
                 @dwDisposition);
  RegSetValueEx(Key,sKey,0,REG_DWORD,@Value,4);
  RegCloseKey(Key);
end;

function GetRegKey(sKey,sValueName:PChar;DefaultValue:DWORD):DWORD;
var
  Key:HKEY;
  dwDisposition,res,dwType,dwSize:DWORD;
begin
  res:=RegCreateKeyEx(HKEY_CURRENT_USER,
                 sKey,
                 0,nil,
                 REG_OPTION_NON_VOLATILE,
                 KEY_READ,
                 nil,key,
                 @dwDisposition);
  if res=ERROR_SUCCESS then begin
    dwSize:=4;
    res:=RegQueryValueEx(Key,sValueName,nil,@dwType,@result,@dwSize);
    if res<>ERROR_SUCCESS then
      result:=DefaultValue;
  end;
  RegCloseKey(Key);
end;

function GetPluginRegKey(sValueName:PChar;DefaultValue:DWORD):DWORD;
var
  Key:HKEY;
  dwDisposition,res,dwType,dwSize:DWORD;
  Keybuf,buf:array[0..MAX_PATH] of char;
begin
  StrPCopy(buf,sRegPktkey);
  StrCat(StrCopy(KeyBuf,Info.RootKey),buf);
  RegCreateKeyEx(HKEY_CURRENT_USER,
                 KeyBuf,
                 0,nil,
                 REG_OPTION_NON_VOLATILE,
                 KEY_ALL_ACCESS,
                 nil,key,
                 @dwDisposition);
  res:=ERROR_SUCCESS;
  if dwDisposition=REG_OPENED_EXISTING_KEY then begin
    dwSize:=4;
    res:=RegQueryValueEx(Key,sValueName,nil,@dwType,@result,@dwSize);
  end;
  if (dwDisposition=REG_CREATED_NEW_KEY) or (res<>ERROR_SUCCESS) then begin
    RegSetValueEx(Key,sValueName,0,REG_DWORD,@DefaultValue,4);
    result:=DefaultValue;
  end;
  RegCloseKey(Key);
end;

end.