(*
  PktView plugin for FAR manager 
  (c) 2001 by Eugene Kotlyarov  http://esk.nm.ru/far
  Distributed under GPL (see GNU_GPL.txt for details)

  Configuration for PktView

  $Id: PktVCfg.pas,v 1.1.1.1 2001/01/21 18:42:01 ek Exp $
*)
{$I PktVDef.inc}
unit PktVCfg;
interface
uses Windows;
const
  sShowkludges='ShowKludges';
  sRightMargin='RightMargin';
  sPanelMode='PanelMode';
  sShowInPluginMenu='ShowInPluginMenu';

type
  TPluginConfig= record
    ShowKludges:BOOL;
    RightMargin:DWORD;
    PanelMode:DWORD;
    FullScreen:DWORD;
    ShowInPluginMenu:DWORD;
    Opened:Boolean;
  end;

var
  PluginConfig:TPluginConfig;

function Configure(ItemNumber:integer):integer;
  stdcall; export;

implementation
uses SysUtils, FarIntf, FarUtil, PktVLang;

function Configure(ItemNumber:integer):integer;
var
  buf1:array[0..10] of char;
  ErrorCode:integer;
const
  d1:DWORD=0;
begin
  result:=0;
  repeat
    ErrorCode:=0;
    StrPCopy(Buf1,IntToStr(PluginConfig.RightMargin));
    if not Dialog(nil,[
      Integer(DI_DOUBLEBOX), 3,  1, 35, 0, 0, DIF_NONE, Integer(MConfigCaption),
      Integer(DI_FIXEDIT),   5,  2,  7, 1, 0, DIF_NONE, buf1,
      Integer(DI_TEXT),      9,  2, 22, 0, 0, DIF_NONE, Integer(MRightMargin),

      Integer(DI_CHECKBOX),  5,  4,  6, 0, 
		@PluginConfig.ShowKludges, DIF_NONE, Integer(MShowKludges),
      Integer(DI_CHECKBOX),  5,  5,  6, 0, 
		@PluginConfig.ShowInPluginMenu, DIF_NONE, Integer(MShowInPluginMenu),
      Integer(DI_BUTTON),    0,  7,  0, 0, 1, DIF_CENTERGROUP, Integer(MOK),
      Integer(DI_BUTTON),    0,  7,  0, 0, 0, DIF_CENTERGROUP, Integer(MCancel)
    ]) then Exit;
    try
      d1:=StrToInt(buf1);
    except
      HandleException;
      ErrorCode:=1;
    end;
  until ErrorCode=0;
  PluginConfig.RightMargin:=d1;
  SetRegKey(sShowKludges,DWORD(PluginConfig.ShowKludges));
  SetRegKey(sRightMargin,PluginConfig.RightMargin);
  SetRegKey(sShowInPluginMenu,PluginConfig.ShowInPluginMenu);
  result:=0;
end;

end.