(*
  PktView plugin for FAR manager 
  (c) 2001 by Eugene Kotlyarov  http://esk.nm.ru/far
  Distributed under GPL (see GNU_GPL.txt for details)

  Working with messages from PKT file

  $Id: PktVMsg.pas,v 1.4 2001/03/18 09:23:35 ek Exp $
*)
{$I PKTVDef.inc}
unit PktVMsg;
interface

uses FmaDef;

procedure ExportMessage(
	harea:TAreaHandle;
	msgn:TMsgNumber;
	FileName:PChar;
	ShowKludges:boolean;
	RightMargin:cardinal);

procedure EditMsgText(
	harea:TAreaHandle;
	msgn:TMsgNumber;
	RightMargin:cardinal);

implementation
uses Windows, SysUtils, FarIntf, 
	 FmaSys, FmaApi, FmaUti, FmaCtrl, FtsApi, PktApi, PktApiP
{$IFDEF FMA_STATIC_LINKAGE} ,FmaObj {$ENDIF};

procedure WriteLine(var f:Text;sLine:PChar);
var 
  s:string;
  i:integer;
begin
  s:=StrPas(sLine);
  i:=1;
  while i<=Length(s) do begin
    if s[i]=#10 then
      Delete(s,i,1)
    else
      Inc(i);
  end;
  Write(f,s,#13);
end;

function GetStringFMP(fmm:PFMM;t:UINT):string;
var fmp:PFMP;
begin
  fmp:=FmaGetFmp(fmm,t,0);
  if (fmp<>nil) 
    then Result:=StrPas(PFMPPSZ(fmp));
end;

function IsSpace(c:char):boolean;
begin
  result:=(c=' ') or (c=#09);
end;

function IsKludge(s:PChar):boolean;
begin
  result:=False;
  if s=nil then exit;
  result:=(s^=#01) or (StrLComp(s,'SEEN-BY:',8)=0);
end;

// get next line with wrapping
function GetNextLine(
	Txt:PChar;
	Buf:PChar;BufSize:integer;
	RightMargin:DWORD):PChar;
var
  LinePos:cardinal;
  LastSpacePos:PChar;
begin
  LinePos:=0;
  LastSpacePos:=Txt;

  while (Txt^<>#0) do begin
    Buf^:=#0;
    if (Txt^=#10) then begin
      Inc(Txt);
      continue;
    end;
    if (Txt^=#13) then begin
      Inc(Txt);
      result:=Txt;
      exit;
    end;
    if (LinePos > RightMargin) then begin
      Buf[StrLen(Buf)-(Txt-LastSpacePos)]:=#0;
      Inc(LastSpacePos);
      result:=LastSpacePos;
      exit;
    end;
    if (IsSpace(Txt^)) then begin
      LastSpacePos:=Txt;
    end;
    Buf^:=Txt^;
    Inc(Buf);
    Inc(LinePos);
    Inc(Txt);
    Buf^:=#0;
  end;
  Result:=Txt;
end;

procedure ExportMsgText(Txt:PChar;FileName:PChar;
	ShowKludges:boolean;RightMargin:DWORD);
var 
  bIsKludge:boolean;
  buf:array[0..255] of Char;
  ptmp:PChar;
  FMsg:Text;
begin
  if (Txt=nil) or (FileName=nil) then Exit;
  Assign(Fmsg,FileName);
  try
    Append(Fmsg);
  except
    ReWrite(Fmsg);
  end;
  while (Txt^<>#0) do begin
    if (IsKludge(Txt)) or (RightMargin=0) then begin // do not wrap kludges
      ptmp:=StrScan(Txt,#13);
      if ptmp=nil then begin // last line in message
        ptmp:=StrEnd(Txt);
        WriteLine(fMsg,Txt);
        Txt:=ptmp;
      end else begin
        ptmp^:=#0;
        WriteLine(fMsg,Txt);
        ptmp^:=#13;
        Txt:=ptmp+1;
      end;
      Continue;
    end;
    Txt:=GetNextLine(Txt,buf,sizeof(buf),RightMargin);
    bIsKludge:=IsKludge(buf);
    if ((not bIsKludge) or (bIsKludge and ShowKludges)) then 
      WriteLine(fMsg,buf);
  end;
  CloseFile(FMsg);
end;

function PFMPPPSZ(afmp:PFMP;idx:cardinal):PChar;
type
  PPChar=^PChar;
begin
  Result := PPChar(DWORD(afmp) + 
             (sizeof(AFMP^) + idx*sizeof(PPChar)))^;
end;

function GetAttrString(fmm:PFMM):string;
var
  sattr:PChar;
  uattrmask:ULONG;
begin
  result:='';
  uattrmask:=1;
  while uattrmask<>0 do begin
    sattr:=FmaGetFlagFromAttr(fmm^.attr and uattrmask);
    if sattr<>nil then result:=result+' '+StrPas(sattr);
    uattrmask:=uattrmask shl 1;
  end;
end;

(* 뢮 ᮮ饭  䠩 *)
procedure ExportMessage(
	harea:TAreaHandle;
	msgn:TMsgNumber;
	FileName:PChar;
	ShowKludges:boolean;
	RightMargin:cardinal);
var
  fmsg:Text;
  buf,buf1:array [0..200] of char;
  sArea:string;
  fmm:PFMM;
  fmpr:PFMP;
  fl:ULONG;
  pchCtrl,pchText:PChar;
  cchCtrl,cchText:ULONG;
  hMsg:TMsgHandle;
begin
  hmsg:=PktOpenMsg(harea, OPENMSG_READ, msgn, 0);
  if (hmsg=nil) then exit;
  Assign(Fmsg,FileName);
  ReWrite(Fmsg);
  try
    StrFmt(Buf,'%s',[StringOfChar('=',79)]); 
    WriteLine(Fmsg,Buf);
    if (not PktLoadMsg(hmsg,fmm,0)) then exit;

    fmpr:=FmaGetFmp(fmm, FMP_DTTMWRITTEN, 0);
    fl:=FDTTM_4DIGITYEAR or FDTTM_TIMESECONDS;
	FmaFormatDttm(buf1, sizeof(buf1), PFMPDTTM(fmpr), fl, '.', #0, NIL);

	sArea:=GetStringFMP(fmm,FMP_AREA);
	if sArea='' then sArea:='NETMAIL';
	FillChar(buf,sizeof(buf),0);
    StrFmt(buf,'Area: %-30s %-22s%18s',
           [sArea,GetAttrString(fmm),buf1]);
    WriteLine(Fmsg,buf);

    StrFmt(buf,'From: %-36s %s ',
            [GetStringFMP(fmm,FMP_SENDERNAME),GetStringFMP(fmm,FMP_ORIGADDR)]);
    WriteLine(Fmsg,Buf);

    if sArea='NETMAIL' then 
    	StrFmt(buf,'To  : %-36s %s',
            [GetStringFMP(fmm,FMP_RECEVRNAME),GetStringFMP(fmm,FMP_DESTADDR)])
    else
    	StrFmt(buf,'To  : %-36s', [GetStringFMP(fmm,FMP_RECEVRNAME)]);

    WriteLine(FMsg,Buf);

    StrFmt(Buf,'Subj: %s',[GetStringFMP(fmm,FMP_SUBJECT)]);
    WriteLine(Fmsg,Buf);

    StrFmt(Buf,'%s',[StringOfChar('=',79)]);    
    WriteLine(Fmsg,Buf);
  finally
    Close(fmsg);
  end;
  FmaDestroyMsg(fmm);

  cchText:=PRM_GETALLTEXT;
  pchText:=nil;
  cchCtrl:=PRM_GETCTRLPTR;
  pchCtrl:=nil;
  if (PktReadMsg(hmsg, nil, pchCtrl, @cchCtrl, pchText, @cchText, nil)) then begin
    if (ShowKludges) then
      ExportMsgText(pchCtrl,FileName,ShowKludges,RightMargin);
    ExportmsgText(pchText,FileName,ShowKludges,RightMargin);
    FmaMemFree(pchText);
  end;

  FmaCloseMsg(hmsg);
end;


procedure EditMsgText(
	harea:TAreaHandle;
	msgn:TMsgNumber;
	RightMargin:cardinal);

function IsEomKludge(s:PChar):boolean;
begin
  Result:=False;
  if StrLComp(s,#1'PATH:',6)=0 then begin result:=True; exit; end;
  if StrLComp(s,#1'Via ',5)=0 then begin result:=True; exit; end;
  if StrLComp(s,#1'Recd ',6)=0 then begin result:=True; exit; end;
  if StrLComp(s,#1'Forwarded ',11)=0 then begin result:=True; exit; end;
end;

var
  Path,buf:array[0..MAX_PATH] of char;
  hmsg:TMsgHandle;
  f:File;
  MsgText:PChar;
  fsize,i,lenkl:ULONG;
  ptmp2,ptmp,pchCtrl,pchText:PChar;
  cchCtrl,cchText:ULONG;
  mh:FMH;
begin
  GetTempPath(sizeof(Path),Path);
  StrFmt(buf,'%0.4d.pms',[msgn]);
  StrCat(Path,buf);
  hmsg := PktOpenMsg(harea,	OPENMSG_READ, msgn,0);
  if (hmsg=nil) then exit;

  cchText:=PRM_GETALLTEXT;
  pchText:=nil;
  cchCtrl:=PRM_GETCTRLPTR;
  pchCtrl:=nil;
  PktReadMsg(hmsg, @mh, pchCtrl, @cchCtrl, pchText, @cchText, nil);
  ExportMsgText(pchCtrl, Path, True, RightMargin);
  ExportmsgText(pchText, Path, True, RightMargin);
  FmaMemFree(pchText);
  PktCloseMsg(hmsg);

  if (Info.Editor(Path,NIL,0,0,-1,-1,0,0,0) = 1) then begin
    Assign(F,Path);
    Reset(F,1);
	fsize:=FileSize(f);
	MsgText:=StrAlloc(fsize+1);
	MsgText[fsize]:=#0;
	BlockRead(f,MsgText^,fsize);
	Close(f);

	// getting and removing kludges from message text 
	// (I hope it works in all cases ;)
	cchCtrl:=0;
	pchCtrl:=AllocMem(1);
	pchCtrl^:=#0;
	i:=0;
	while MsgText[i]<>#0 do begin
	  if MsgText[i]=#1 then begin 
	    if IsEomKludge(@MsgText[i]) then break;
	    ptmp:=StrScan(@MsgText[i+1],#13); // find end of line
	    if (ptmp=nil) then break;         // kludge at last line of message
	    lenkl:=ptmp-@MsgText[i]+1;        // length of kludge
	    ptmp2:=@pchCtrl[cchCtrl];         // where to add new kludge
	    cchCtrl:=cchCtrl+lenkl;           // new size of ctrl info
	    ReallocMem(pchCtrl,cchCtrl+1);    // reallocmem for kludges
	    Move(MsgText[i],ptmp2^,lenkl);    // add new kludge to kludges
	    StrCopy(@MsgText[i],ptmp+1);      // remove kludges from text
	    Dec(i);
	  end;
	  Inc(i);
	end;
	pchCtrl[cchCtrl]:=#0;
	pchText:=MsgText;

    hmsg := PktOpenMsg(harea, OPENMSG_CREATE, msgn, 0);
    if (hmsg<>nil) then begin
      PktWriteMsg(hmsg, @mh, pchCtrl, StrLen(pchCtrl),
      		pchText,StrLen(pchText),nil,StrLen(pchText));
      PktCloseMsg(hMsg);
	end;
	FreeMem(pchCtrl);
    StrDispose(MsgText);
  end;
  DeleteFile(Path);
end;

end.