(*
  PktView plugin for FAR manager 
  (c) 2001 by Eugene Kotlyarov  http://esk.nm.ru/far
  Distributed under GPL (see GNU_GPL.txt for details)

  Main library module

  $Id: PktView.dpr,v 1.1.1.1 2001/01/21 18:42:01 ek Exp $
*)

{$I PktVDef.inc}
library PktView;
uses Windows, SysUtils, FarIntf, PktVClass, PktVCfg;
  

procedure SetStartupInfo(var _Info:TPluginStartupInfo); stdcall; export;
begin
  Info:=_Info;
  TPktPlugin.SetStartupInfo(_Info);
end;

procedure GetOpenPluginInfo(
  hPlugin: THandle;
  var Info: TOpenPluginInfo);
  stdcall; export;
begin
  TPktPlugin(hPlugin).GetOpenPluginInfo(Info);
end;

procedure GetPluginInfo(var PluginInfo:TPluginInfo);
  stdcall; export;
begin
  TPktPlugin.GetPluginInfo(PluginInfo);
end;

function OpenFilePlugin(
  const Name: PChar;
  var Data;
  DataSize: Integer): THandle;
  stdcall; export;
begin
  Result:=TPktplugin.OpenFilePlugin(Name, Data, DataSize);
end;

function OpenPlugin(OpenFrom:OPEN;Item:INTEGER):THandle;
  stdcall; export;
begin
  Result:=TPktPlugin.OpenPlugin(OpenFrom,Item);
end;

procedure ClosePlugin(hPlugin:THandle); stdcall; export;
begin
  TPktPlugin(hPlugin).Free;
end;

function GetFindData(
  hPlugin: THandle;
  var PanelItems: PPluginPanelItemsArray;
  var ItemsNumber: Integer;
  OpMode: Integer): Integer;
  stdcall; export;
begin
  Result := 0;
  try
    Result := Ord(TPktPlugin(hPlugin).GetFindData(
      PanelItems,
      ItemsNumber,
      OpMode));
  except
    HandleException;
  end;
end;

procedure FreeFindData(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer);
  stdcall; export;
begin
  try
    TPktPlugin(hPlugin).FreeFindData(
      PanelItems,
      ItemsNumber);
  except
    HandleException;
  end;
end;

function GetFiles(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer;
  Move: LongBool;
  DestPath: PChar;
  OpMode: Integer): integer;
  stdcall; export;
begin
  Result := 0;
  try
    Result:=Ord(TPktPlugin(hPlugin).GetFiles(
      PanelItems,
      ItemsNumber,
      Move,
      DestPath,
      OpMode));
  except
    HandleException;
  end;
end;

function ProcessKey(
  hPlugin:THandle;
  Key:integer;
  ControlState:cardinal):integer;
  stdcall; export;
begin
  Result:=TPktPlugin(hPlugin).ProcessKey(Key,ControlState);
end;

function ProcessEvent(
  hPlugin:THANDLE;
  Event:FE;
  Param:pointer
):integer;stdcall; export;
begin
  Result:=TPktPlugin(hPlugin).ProcessEvent(Event,Param);
end;

function DeleteFiles(
  hPlugin:THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber:integer;
  OpMode:integer
):integer; stdcall; export;
begin
  Result:=0;
  try
    Result:=Ord(TPktPlugin(hPlugin).DeleteFiles(PanelItems,ItemsNumber,OpMode));
  except
    HandleException;
  end;
end;

function Compare (
  hPlugin:THandle;
  var Item1:TPluginPanelItem;
  var Item2:TPluginPanelItem;
  Mode:OPENPLUGININFO_SORTMODES
):integer;stdcall; export;
var
  res,col:integer;
begin
  Result:=-2;
  case Mode of
    SM_MTIME:col:=1;
    SM_CTIME:col:=2;
    SM_ATIME:col:=3;
  else
    col:=0;
  end;
  if Col<>0 then begin
    res:=lstrcmpi(Item1.CustomColumnData^[col],Item2.CustomColumnData^[col]);
    if (res>0) then Result:=1
    else if (res<0) then Result:=-1
    else if (res=0) then Result:=0;
  end;
end;
(*
procedure VPSuxx;
var
  timer:time_t;
begin
  _errno;			  	_sopen(nil,0,0);	_close(0);        
  _tell(0);       		_lseek(0,0,0); 		_filelength(0);
  _chsize(0,0);       	_read(0,nil,0);     _write(0,nil,0);    	
  _locking(0,0,0);  	_unlink(nil);      	_mkdir(nil);
  _memset(nil,0,0);   	_realloc(nil,0);  	_strlen(nil);
  _memcpy(nil,nil,0);   _strchr(nil,0)     	_atol(nil);
  _time(timer);       	_strcat(nil,nil);   _memmove(nil,nil,0);  
  _strncpy(nil,nil,0);  _memcmp(nil,nil,0); _strrchr(nil,0);
  _memchr(nil,0,0);
end;
*)
exports
	SetStartupInfo,
	GetOpenPluginInfo,
	GetPluginInfo,
	OpenFilePlugin,
	OpenPlugin,
	GetFindData,
	FreeFindData,
	GetFiles,
	DeleteFiles,
	ClosePlugin,
	ProcessKey,
	ProcessEvent,
	Configure,
	Compare;

// for VP must be initialization
{$IFDEF VIRTUALPASCAL}
initialization
{$ELSE}
begin
{$ENDIF}
end.
